part of katana_routing;

/// Theme data for images.
@immutable
class ImageTheme {
  const ImageTheme({
    this.landingBackgroundImage,
    this.landingFeatureImage,
    this.backgroundImage,
    this.bootBackgroundImage,
    this.bootFeatureImage,
    this.homeFeatureImage,
  });

  /// Get ImageTheme.
  ///
  /// You can check the current widget setting.
  static ImageTheme of(BuildContext context) {
    return (context
            .getElementForInheritedWidgetOfExactType<ThemeScope>()!
            .widget as ThemeScope)
        .imageTheme;
  }

  /// Landing Page Background.
  final String? landingBackgroundImage;

  /// Landing page featured image.
  final String? landingFeatureImage;

  /// Feature image of the boot screen.
  final String? bootFeatureImage;

  /// Background image of the boot screen.
  final String? bootBackgroundImage;

  /// Normal screen background.
  final String? backgroundImage;

  /// Featured image of the home screen.
  final String? homeFeatureImage;
}
